<template>
  <div class="app-container">
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" style="float: left;margin-right:10px;" @click="form_add">分配</el-button>
      <el-button v-if="isRoleEdit" class="danger" style="float: left;margin-right:10px;" @click="handleDelete">删除</el-button>
      <el-button v-if="isRoleEdit" class="import" style="float: right;" @click="form_inport">导入</el-button>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="form_export(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="form_export(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>

    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.times" filterable placeholder="班次" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="(item,index) in frequencyList" :key="index" :label="item.name" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.eqclass" placeholder="设备类别" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="(item,index) in equipmentCategoryList" :key="index" :label="item.name" :value="item.name" />
      </el-select>
      <el-input ref="eqcode" v-model="table.getdataListParm.parammaps.eqcode" class="filter-item" placeholder="设备编号" style="width: 120px;" />
      <el-input ref="driver" v-model="table.getdataListParm.parammaps.driver" class="filter-item" placeholder="驾驶员" style="width: 120px;" />
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="form_clear">重置</el-button>
    </div>
    <div class="table">
      <el-table :key="table.tableKey" v-loading="table.listLoading" element-loading-text="给我一点时间" :data="table.list" border fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed" @selection-change="change_table_selection">
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="生效日期" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.operatetime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="班次" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.times }}</span>
          </template>
        </el-table-column>
        <el-table-column label="设备类别" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.eqclass }}</span>
          </template>
        </el-table-column>
        <el-table-column label="设备编号" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.eqcode }}</span>
          </template>
        </el-table-column>
        <el-table-column label="驾驶员" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.driver }}</span>
          </template>
        </el-table-column>
        <el-table-column label="分配人" min-width="110px" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <span>{{ scope.row.emp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="250" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="isRoleEdit" class="miniDanger" @click="form_delete(row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="get_table_data" />
    </div>

    <!-- 新增/编辑 -->
    <el-dialog :title="textMap[create.dialogStatus]" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <div class="app-add">
        <el-tabs v-model="create.activeName" @tab-click="handleClick">
          <el-tab-pane label="TMR设备" name="first">
            <div class="table">
              <el-table :key="create.tableKey" v-loading="create.listLoading" element-loading-text="给我一点时间" :data="create.list" border fit highlight-current-row style="width: 100%;margin-bottom: 50px;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed">
                <el-table-column label="班次" min-width="150px" align="center">
                  <template slot-scope="scope">
                    <span>{{ scope.row.timesstr }}</span>
                  </template>
                </el-table-column>
                <el-table-column label="设备类别" min-width="110px" align="center" show-overflow-tooltip>
                  <template slot-scope="scope">
                    <span>{{ scope.row.eqclass }}</span>
                  </template>
                </el-table-column>
                <el-table-column label="设备编号" min-width="100px" align="center">
                  <template slot-scope="scope">
                    <span>{{ scope.row.eqcode }}</span>
                  </template>
                </el-table-column>
                <el-table-column label="驾驶员" min-width="110px" align="center" show-overflow-tooltip>
                  <template slot-scope="scope">
                    <el-select v-model="scope.row.driverid" filterable placeholder="驾驶员" class="filter-item" style="width: 100%;padding: 0 10px;" @change="(value)=> {changeDriver(value, scope.row)}">
                      <el-option v-for="(item,index) in driverList" :key="index" :label="item.drivername" :value="item.id" />
                    </el-select>
                  </template>
                </el-table-column>
              </el-table>
            </div>
            <div slot="footer" class="dialog-footer">
              <el-button class="cancelClose" @click="create.dialogFormVisible = false;get_table_data()">关闭</el-button>
              <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="success" :disabled="isokDisable" @click="add_dialog_save()">确认</el-button>
            </div>
          </el-tab-pane>
          <el-tab-pane label="铲车" name="second">
            <div class="table">
              <el-table :key="create.tableKey2" v-loading="create.listLoading2" element-loading-text="给我一点时间" :data="create.list2" border fit highlight-current-row style="width: 100%;margin-bottom: 50px;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed">
                <el-table-column label="班次" min-width="150px" align="center">
                  <template slot-scope="scope">
                    <span>{{ scope.row.timesstr }}</span>
                  </template>
                </el-table-column>
                <el-table-column label="设备类别" min-width="110px" align="center" show-overflow-tooltip>
                  <template slot-scope="scope">
                    <span>{{ scope.row.eqclass }}</span>
                  </template>
                </el-table-column>
                <el-table-column label="设备编号" min-width="100px" align="center">
                  <template slot-scope="scope">
                    <span>{{ scope.row.eqcode }}</span>
                  </template>
                </el-table-column>
                <el-table-column label="驾驶员" min-width="110px" align="center" show-overflow-tooltip>
                  <template slot-scope="scope">
                    <el-select v-model="scope.row.driverid" filterable placeholder="驾驶员" class="filter-item" style="width: 100%;padding: 0 10px;" @change="(value)=> {changeDriver(value, scope.row)}">
                      <el-option v-for="(item,index) in driverList" :key="index" :label="item.drivername" :value="item.id" />
                    </el-select>
                  </template>
                </el-table-column>
              </el-table>
            </div>
            <div slot="footer" class="dialog-footer">
              <el-button class="cancelClose" @click="create.dialogFormVisible = false;get_table_data()">关闭</el-button>
              <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="success" :disabled="isokDisable" @click="add_dialog_save2()">确认</el-button>
            </div>
          </el-tab-pane>
        </el-tabs>

      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, PostDataByName, ExecDataByConfig, GetDataByNames, checkButtons, calculativeWidth } from '@/api/common'
import Cookies from 'js-cookie'
import { parseTime } from '@/utils/index.js'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
export default {
  name: 'DutyRecord',
  components: { Pagination },
  data() {
    return {
      isRoleEdit: [],
      send_select_list: [
        { name: 'getSysoptEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid'), 'inforname': 'times' } },
        { name: 'getDriverListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') } }
      ],
      equipmentCategoryList: [{ id: '1', name: 'TMR设备' }, { id: '2', name: '铲车' }], // 设备类别
      frequencyList: [], // 班次
      driverList: [], // 驾驶员

      table: {
        getdataListParm: {
          name: 'getDutyrecordList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            startTime: '',
            stopTime: '',
            inputDatetime: '',
            times: '',
            eqclass: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },

      // 新增/编辑
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: { pastureid: Cookies.get('pastureid'), operatetime: parseTime(new Date(), '{y}-{m}-{d} {h}:{m}'), emp: Cookies.get('employename'), barid: '', barname: '', remain: '', times: '' },
        rules: {},
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        getdataListParm: {
          name: 'geEqListByDplan',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        tableKey2: 0,
        list2: [],
        total2: 0,
        listLoading2: true,
        getdataListParm2: {
          name: 'geEqListByDplan',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        activeName: 'first'
      },
      textMap: {
        create: '分配'
      },
      requestParam: {},
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' }
    }
  },

  created() {
    this.get_table_data()
    this.get_select_list()
    this.get_auto_buttons()
  },

  methods: {
    get_auto_buttons() {
      const Edit = 'DutyRecord'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    get_select_list() {
      GetDataByNames(this.send_select_list).then(response => {
        if (response.data.getSysoptEnable.list !== null) {
          for (let i = 1; i <= response.data.getSysoptEnable.list[0].inforvalue; i++) {
            const obj = {}
            obj.id = String(i)
            if (i == 1) { obj.name = '第一班' } else if (i == 2) { obj.name = '第二班' } else if (i == 3) { obj.name = '第三班' } else if (i == 4) { obj.name = '第四班' }
            this.frequencyList.push(obj)
          }
        } else {
          this.frequencyList = []
        }
        this.driverList = response.data.getDriverListEnable.list
      })
    },

    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },
    form_clear() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.times = ''
      this.table.getdataListParm.parammaps.eqclass = ''
      this.table.getdataListParm.parammaps.eqcode = ''
      this.table.getdataListParm.parammaps.driver = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },

    // 新增

    form_add() {
      console.log('点击了分配')
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
      this.getDialogList()
    },
    handleClick() {
      if (this.create.activeName == 'first') {
        this.getDialogList()
      } else if (this.create.activeName == 'second') {
        this.getDialogList2()
      }
    },
    getDialogList() {
      GetDataByName(this.create.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].driver == undefined || response.data.list[i].driverid == undefined) {
              this.$set(response.data.list[i], 'driver', '')
              this.$set(response.data.list[i], 'driverid', '')
            }
          }
          this.create.list = response.data.list
        } else {
          this.create.list = []
        }
        setTimeout(() => {
          this.create.listLoading = false
        }, 100)
      })
    },
    getDialogList2() {
      GetDataByName(this.create.getdataListParm2).then(response => {
        console.log('table2数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].driver == undefined || response.data.list[i].driverid == undefined) {
              this.$set(response.data.list[i], 'driver', '')
              this.$set(response.data.list[i], 'driverid', '')
            }
          }
          this.create.list2 = response.data.list
        } else {
          this.create.list2 = []
        }
        setTimeout(() => {
          this.create.listLoading2 = false
        }, 100)
      })
    },
    changeDriver(item, row) {
      row.driver = this.driverList.find(obj => obj.id == item).drivername
    },

    add_dialog_save() {
      console.log('点击了新增保存', this.create.list)
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)

      for (var i = 0; i < this.create.list.length; i++) {
        if (this.create.list[i].driverid == '') {
          this.create.list.splice(i, 1)
          i = 0
        }
      }

      console.log('点击了新增保存', this.create.list)
      this.requestParam.common = { 'returnmap': '0' }
      this.requestParam.data = []
      this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.create.list } }
      this.requestParam.data[0].children = []
      this.requestParam.data[0].children[0] = {        'name': 'insertDutyrecord', 'type': 'e', 'parammaps': {
          pastureid: '@insertSpotList.pastureid',
          eqid: '@insertSpotList.eqid',
          eqclass: '@insertSpotList.eqclass',
          eqcode: '@insertSpotList.eqcode',
          driver: '@insertSpotList.driver',
          driverid: '@insertSpotList.driverid',
          times: '@insertSpotList.times',
          operatedate: parseTime(new Date(), '{y}-{m}-{d}'),
          emp: Cookies.get('employename')
        }      }
      ExecDataByConfig(this.requestParam).then(response => {
        console.log('分配TMR设备保存发送参数', this.requestParam)
        if (response.msg === 'fail') {
          this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
        } else {
          this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
          this.create.dialogFormVisible = false
          this.get_table_data()
        }
      })
    },
    add_dialog_save2() {
      console.log('分配铲车保存发送参数')
    },

    // 删除
    form_delete(row) {
      console.log('点击了行内删除')
      this.selectList = []
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteDutyrecord'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.get_table_data()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    change_table_selection(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    handleDelete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择值班记录', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList } }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {            'name': 'deleteDutyrecord', 'type': 'e', 'parammaps': {
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid'
            }          }
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.get_table_data()
            }
          })
        })
      }
    },

    // 导出
    form_export(item) {
      if (item == 1) {
        console.log('点击了导出模板')
      } else {
        console.log('点击了导出数据')
      }
    },

    // 导入
    form_inport() {
      console.log('点击了导入')
    }

  }
}
</script>
<style lang="scss" scoped>
.search {
  padding-top: 10px;
  clear: both;
}
.table {
  margin-top: 10px;
}
</style>
